// $Id: utility.cc 69 2006-02-11 00:44:22Z jari $

#include <c++_tools/utility/utility.h>

#include <iostream>
#include <sstream>
#include <string>
#include <vector>

namespace theplu {
namespace utility {


	bool is_float(const std::string& s)
	{
		// have decimal point
		bool dp = false;
		size_t i = 0;
		if ((s[i]=='-') || (s[i]=='+')) {
      i++;
			// empty after sign
      if (i >= s.size())
				return false;
		}
		bool isf = false;
		while (i<s.size()) {
			if ((s[i]<'0') || (s[i]>'9')) {
					if (s[i] == '.') {
						// two decimals
						if (dp)
							return false;
						else
							dp = true;
					}
					else if ((s[i]=='E') || (s[i]=='e')) {
						i++;
						// nothing following E
						if (i>=s.size())
							return false;
						std::string tmp_str(s,i);
						return is_int(tmp_str);
					}
			}
      else
				isf = true;
			i++;
		}
		return isf;
	}



	bool is_int(const std::string& s)
	{
		size_t i = 0;
		if ((s[i]=='-') || (s[i]=='+')) { 
			i++;
			// nothing following sign
			if (i>=s.size())
				return false;
		}
		while (i<s.size()) {
			if ((s[i]<'0') || (s[i]>'9'))
				return false;
			i++;
		}
		return true;
	}


}} // end of namespace utility and namespace thep
